/* bgdoc.rex: a program for BIG dogs ...  */

myDog = .BigDog~new     /* create a BIG dog from the class      */
myDog~Name = "Arnie"    /* tell the dog what it is called       */
say "My name is:" myDog~Name    /* now ask the dog for its name */
myDog~Bark              /* come on show them who you are!       */

::class  Dog            /* define the class "Dog"               */
::method Name attribute /* let it have an attribute             */
::method Bark           /* let it be able to bark               */
  say "Woof! Woof! Woof!"

  /* the following class reuses most of what is already
     defined for the class "Dog" via inheritance; it overrides
     the way a big dog barks                                    */
::class  BigDog subclass Dog    /* define the class "BigDog"    */
::method Bark           /* let it be able to bark               */
  say "WOOF! WOOF! WOOF!"

/* yields:

   My name is: Arnie
   WOOF! WOOF! WOOF!

*/

